#ct_graphs.py
import pandas as pd
import numpy as np
import matplotlib.pyplot as plt
import seaborn as sns
import gc
from datetime import datetime
import matplotlib.dates as mdates
from numpy import inf


df = pd.read_csv('Desktop/Desktop/correct_full_final_fin_nodupe.csv')
df.log_light.replace(-inf, np.log(0.0000000000000001), inplace =True)
df = df.drop_duplicates()

#df = df[df['year']<=2020]
df['light'] = (np.exp(df['log_light'])-1)
df['ll_light'] = (np.log(df['light']))


hurricanes =['hermine','matthew','harvey', 'irma','florence','michael','dorian']
df['month-year'] = df['month'].astype(str) + '-' + df['year'].astype(str)
df['plot_time'] = df['month-year'].apply(lambda x: datetime.strptime(x, '%m-%Y'))
df['year_mod'] = df['year'].apply(lambda x: datetime.strptime(str(x), '%Y'))
dist_mo = [8,10,8,9,9,10,9]
dist_yr = [2016,2016,2017,2017,2018,2018,2019]
cutoff_dates = list(zip(dist_mo, dist_yr))
dict_zip = dict(zip(hurricanes, cutoff_dates))

#hurricanes_mod =['irma','michael','dorian']

for h in hurricanes_mod:
    newdf = df[df.hurricane == h]
    print (h)
    test = newdf[newdf.year==2019]
    print ('2019')
    print(test.groupby(['month'])['log_light'].mean())
    print (h)
    print ('2020')
    test1 = newdf[newdf.year==2020]
    print(test1.groupby(['month'])['log_light'].mean())



for h in hurricanes:
    disaster_month = dict_zip[h][0]
    disaster_year = dict_zip[h][1]
    newdf = df[df.hurricane == h]
    fig, (ax1, ax2) = plt.subplots(nrows=1, ncols=2, sharey=True, sharex=True)
    sns.lineplot(ax=ax1, data=newdf, x='plot_time', y='ll_light', hue='fema_treat', legend=False)
    ax1.set_title('Monthly index')
    ax1.axvline(x=datetime(disaster_year, disaster_month, 1), color='green')
    ax1.xaxis_date() 
    ax1.xaxis.set_major_locator(mdates.AutoDateLocator()) 
    ax1.xaxis.set_major_formatter(mdates.DateFormatter('%Y'))
    ax1.tick_params(axis='x', labelrotation=90)
    ax1.set_ylabel('Log radiance')
    ax1.set_xlabel('')
    sns.lineplot(data=newdf, x='year_mod', y='ll_light', hue='fema_treat', legend=False)
    ax2.set_title('Yearly index')
    ax2.set_xlabel('')
    plt.axvline(x=datetime(disaster_year, 1, 1), color='green')
    #plt.legend(handles= newdf['fema_treat'].unique(),labels=['control','treatment'], loc='best')
    plt.xticks(rotation='vertical')
    fig.suptitle(h.capitalize() + ': Combined Aid')
    plt.savefig('Desktop/ct_graphs/fix_light_ct_combined_'+h+'.png')

del ax1, ax2, fig
gc.collect()

for h in hurricanes:
    disaster_month = dict_zip[h][0]
    disaster_year = dict_zip[h][1]
    newdf = df[df.hurricane == h]
    fig, (ax1, ax2) = plt.subplots(nrows=1, ncols=2, sharey=True, sharex=True)
    sns.lineplot(ax=ax1, data=newdf, x='plot_time', y='ll_light', hue='fema_IA', legend=False)
    ax1.set_title('Monthly index')
    ax1.axvline(x=datetime(disaster_year, disaster_month, 1), color='green')
    ax1.xaxis_date() 
    ax1.xaxis.set_major_locator(mdates.AutoDateLocator()) 
    ax1.xaxis.set_major_formatter(mdates.DateFormatter('%Y'))
    ax1.tick_params(axis='x', labelrotation=90)
    ax1.set_ylabel('Log radiance')
    ax1.set_xlabel('')
    sns.lineplot(data=newdf, x='year_mod', y='ll_light', hue='fema_IA', legend=False)
    ax2.set_title('Yearly index')
    ax2.set_xlabel('')
    plt.axvline(x=datetime(disaster_year, 1, 1), color='green')
    #plt.legend(handles= newdf['fema_treat'].unique(),labels=['control','treatment'], loc='best')
    plt.xticks(rotation='vertical')
    fig.suptitle(h.capitalize() + ': Individual Aid')
    print('finished '+h)
    plt.savefig('Desktop/ct_graphs/fix_light_ct_combined_IA_'+h+'.png')

